#!/bin/perl
###############################################################################
#
# CA Incorporated
# 273 Corporate Drive
# Portsmouth, NH 03801
# Copyright (c) 2010 CA, Inc.
# All rights reserved.
#
# IN NO EVENT SHALL CA INCORPORATED BE LIABLE FOR
# ANY INCIDENTAL, INDIRECT, SPECIAL, OR CONSEQUENTIAL DAMAGES
# WHATSOEVER (INCLUDING BUT NOT LIMITED TO LOST PROFITS) ARISING OUT
# OF OR RELATED TO THIS SOFTWARE, EVEN IF CA INCORPORATED HAS BEEN
# ADVISED OF, KNOWN, OR SHOULD HAVE KNOWN, THE POSSIBILITY OF SUCH
# DAMAGES.
#
#
# Official Version: 1.1.1.2 - Date of Last Included Delta: 12/01/10 
#
###############################################################################

unless (-e "./.installrc") { die "Please run this script from your Spectrum root directory\n" };


print "\nCA Incorporated 273 Corporate Drive Portsmouth, NH 03801 Copyright (c) 2008 CA, Inc.\n\n
  All rights reserved.\n\n
  IN NO EVENT SHALL CA INCORPORATED BE LIABLE FOR\n\n
  ANY INCIDENTAL, INDIRECT, SPECIAL, OR CONSEQUENTIAL DAMAGES\n\n
  WHATSOEVER (INCLUDING BUT NOT LIMITED TO LOST PROFITS) ARISING OUT\n\n
  OF OR RELATED TO THIS SOFTWARE, EVEN IF CA INCORPORATED HAS BEEN\n\n
  ADVISED OF, KNOWN, OR SHOULD HAVE KNOWN, THE POSSIBILITY OF SUCH\n\n\n
  DAMAGES.  Press enter to continue...\n";



chomp ($input = <STDIN>);
print "\nPlease enter the local hostname:";
chomp($local_hostname = <STDIN>);
print "\nPlease enter the hostname of the Main Location Server:";
chomp($mls_hostname = <STDIN>);
$local_hostname =~ s/\..*$//g; # remove domain name
$local_hostname =~ tr/[A-Z]/[a-z]/; # convert to lowercase
$mls_hostname =~ s/\..*$//g; # remove domain name
$mls_hostname =~ tr/[A-Z]/[a-z]/; # convert to lowercase
if (not defined $local_hostname) {
die "Need local SpectroSERVER hostname\n usage: ChangeHostname_Spectrum.pl <local SpectroSERVER hostname> <MLS hostname>\n";
}
if (not defined $mls_hostname) {
die "Need MLS SpectroSERVER hostname\n usage: ChangeHostname_Spectrum.pl <local SpectroSERVER hostname> <MLS hostname>\n";
  exit;
}
$specroot = $ENV{'SPECROOT'};
chdir($specroot);
print "Updating .hostrc\n";
open(OH, "> .hostrc");
print OH "$local_hostname\n";
close(OH);
print "Updating .installrc\n";
open(FH, "< .installrc");
open(OH, "> .installrc.new");
while (<FH>)
{
$_ = "LOCSERV: $local_hostname\n" if ( /^LOCSERV:/ );
print OH;
}
close(FH);
close(OH);
unlink(".installrc");
rename(".installrc.new", ".installrc");
print "Updating UI-CONFIG.$local_hostname\n";
@uicfg = glob("UI-CONFIG.*");
open(FH, "< ". $uicfg[0]);
open(OH, "> UI-CONFIG.$local_hostname");
while (<FH>)
{
$_ = " host = $local_hostname\n" if ( /^ host =/ );
$_ = " ss_host = $local_hostname\n" if ( /^ ss_host =/ );
$_ = " oc_host = $local_hostname\n" if ( /^ oc_host =/ );
print OH;
}
close(FH);
close(OH);
unlink($uicfg[0]);
print "Updating LS/.locrc\n";
open(FH, "< LS/.locrc");
open(OH, "> LS/.locrc.new");
while (<FH>)
{
$_ = "MAIN_LOCATION_HOST_NAME=$mls_hostname\n" if ( /^MAIN_LOCATION_HOST_NAME=/ );
print OH;
}
close(FH);
close(OH);
unlink("LS/.locrc");
rename("LS/.locrc.new", "LS/.locrc");
print "Updating .LocalRegFile\n";
open(FH, "< .LocalRegFile");
open(OH, "> .LocalRegFile.new");
while (<FH>)
{
$_ = "LocationServiceHost=$local_hostname\n" if ( /^LocationServiceHost=/ );
print OH;
}
close(FH);
close(OH);
unlink(".LocalRegFile");
rename(".LocalRegFile.new", ".LocalRegFile");
print "Updating .corbarc\n";
open(FH, "< .corbarc");
open(OH, "> .corbarc.new");
while (<FH>)
{
$_ = "vbroker.se.iiop_tp.proxyHost=$local_hostname\n" if ( /^vbroker.se.iiop_tp.proxyHost=/ );
print OH;
}
close(FH);
close(OH);
unlink(".corbarc");
rename(".corbarc.new", ".corbarc");
while (<FH>)
{
$_ = "vbroker.se.iiop_tp.proxyHost=$local_hostname\n" if ( /^vbroker.se.iiop_tp.proxyHost=/ );
print OH;
}
close(FH);
close(OH);
print "Updating SG-Support/CsResource/preferences/ssroe.prf\n";
open(FH, "< SG-Support/CsResource/preferences/ssroe.prf");
open(OH, "> SG-Support/CsResource/preferences/ssroe.prf.new");
while (<FH>)
{
$_ = " ui = $local_hostname\n" if ( /^ ui =/ );
print OH;
}
close(FH);
close(OH);
unlink("SG-Support/CsResource/preferences/ssroe.prf");
rename("SG-Support/CsResource/preferences/ssroe.prf.new",
"SG-Support/CsResource/preferences/ssroe.prf");
print "Updating tomcat/webapps/spectrum/META-INF/context.xml\n";
open(FH, "< tomcat/webapps/spectrum/META-INF/context.xml");
open(OH, "> tomcat/webapps/spectrum/META-INF/context.xml.new");
while (<FH>)
{
if ( /locServerName=/ )
{
($before, $after) = ($_ =~ m@(.*)locServerName=[^\s]+(.*)@);
$_ = "${before}locServerName=\"$local_hostname\"${after}";
}
if ( /\.proxyHost=/ )
{
($before, $after) = ($_ =~ m@(.*)\.proxyHost=[^\s]+(.*)@);
$_ = "${before}.proxyHost=$local_hostname${after}";
}
print OH;
}
close(FH);
close(OH);
unlink("tomcat/webapps/spectrum/META-INF/context.xml");
rename("tomcat/webapps/spectrum/META-INF/context.xml.new",
"tomcat/webapps/spectrum/META-INF/context.xml");
print "Updating vnmsh/.vnmshrc\n";
open(FH, "< vnmsh/.vnmshrc");
open(OH, "> vnmsh/.vnmshrc.new");
while (<FH>)
{
$_ = "vnm_hostname=$local_hostname\n" if ( /^vnm_hostname=/ );
print OH;
}
close(FH);
close(OH);
unlink("vnmsh/.vnmshrc");
rename("vnmsh/.vnmshrc.new", "vnmsh/.vnmshrc");
print "Completed conversion\n";
